//
//  FirebaseGenerator.swift
//
//
//  Created by Loris Perret on 05/12/2023.
//

import Foundation

enum FirebaseGenerator {
    case service
    
    var content: String {
        [
            FirebaseGenerator.service.header,
            FirebaseGenerator.service.logScreen,
            FirebaseGenerator.service.logEvent,
            FirebaseGenerator.service.footer
        ]
            .joined(separator: "\n")
    }
    
    private var header: String {
        """
        // MARK: - Firebase

        class FirebaseAnalyticsManager: AnalyticsManagerProtocol {
        """
    }
    
    private var logScreen: String {
        """
            func logScreen(name: String, path: String) {
                Analytics.logEvent(AnalyticsEventScreenView, parameters: [AnalyticsParameterScreenName: name])
            }
        
        """
    }
    
    private var logEvent: String {
        """
            func logEvent(name: String) {
                var parameters = [
                    AnalyticsParameterValue: name
                ]
                
                Analytics.logEvent(AnalyticsEventSelectContent, parameters: parameters)
            }
        """
    }
    
    private var footer: String {
        """
        }
        
        """
    }
}
